Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkImplicitFunction Class Reference

`#include <vtkImplicitFunction.h>`

Inheritance diagram for vtkImplicitFunction:

[legend]
Collaboration diagram for vtkImplicitFunction:

[legend]
List of all members.

## Detailed Description

abstract interface for implicit functions

Date:
  2002/12/26 18:24:21

Revision:
  1.51

vtkImplicitFunction specifies an abstract interface for implicit functions. Implicit functions are real valued functions defined in 3D space, w = F(x,y,z). Two primitive operations are required: the ability to evaluate the function, and the function gradient at a given point.

Implicit functions are very powerful. It is possible to represent almost any type of geometry with the level sets w = const, especially if you use boolean combinations of implicit functions (see vtkImplicitBoolean).

vtkImplicitFunction provides a mechanism to transform the implicit function(s) via a vtkAbstractTransform. This capability can be used to translate, orient, scale, or warp implicit functions. For example, a sphere implicit function can be transformed into an oriented ellipse.

Warning:
  The transformation transforms a point into the space of the implicit function (i.e., the model space). Typically we want to transform the implicit model into world coordinates. In this case the inverse of the transformation is required.

See also:
  vtkAbstractTransform vtkSphere vtkCylinder vtkImplicitBoolean vtkPlane vtkPlanes vtkQuadric vtkImplicitVolume vtkSampleFunction vtkCutter vtkClipPolyData

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (36%)
  - Gobbi, David (32%)
  - Lorensen, Bill (12%)
  - Martin, Ken (5%)

CVS logs (CVSweb):
  - .`h` (`/Common/vtkImplicitFunction.h)`
  - .`cxx` (`/Common/vtkImplicitFunction.cxx)`

Definition at line 69 of file vtkImplicitFunction.h.

## Public Types
typedef vtkObject | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
unsigned long | GetMTime ()
virtual void | EvaluateGradient (float x[3], float g[3])=0
float | FunctionValue (const float x[3])
float | FunctionValue (float x, float y, float z)
void | FunctionGradient (const float x[3], float g[3])
float * | FunctionGradient (const float x[3])
float * | FunctionGradient (float x, float y, float z)
virtual void | SetTransform (vtkAbstractTransform *)
virtual vtkAbstractTransform * | GetTransform ()
virtual float | EvaluateFunction (float x[3])=0
float | EvaluateFunction (float x, float y, float z)
## Static Public Methods
int | IsTypeOf (const char *type)
vtkImplicitFunction * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkImplicitFunction ()
| ~vtkImplicitFunction ()
## Protected Attributes
vtkAbstractTransform * | Transform
float | ReturnValue [3]

## Member Typedef Documentation

typedef vtkObject vtkImplicitFunction::Superclass

| Reimplemented from vtkObject. Reimplemented in vtkPlane, vtkPlanes, vtkQuadric, vtkCone, vtkCylinder, vtkImplicitBoolean, vtkImplicitDataSet, vtkImplicitSelectionLoop, vtkImplicitSum, vtkImplicitVolume, vtkImplicitWindowFunction, vtkPerlinNoise, vtkSphere, and vtkSuperquadric. Definition at line 72 of file vtkImplicitFunction.h.

## Constructor & Destructor Documentation

vtkImplicitFunction::vtkImplicitFunction | ( |  | ) | `[protected]`

vtkImplicitFunction::~vtkImplicitFunction | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkImplicitFunction::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkObject. Reimplemented in vtkPlane, vtkPlanes, vtkQuadric, vtkCone, vtkCylinder, vtkImplicitBoolean, vtkImplicitDataSet, vtkImplicitSelectionLoop, vtkImplicitSum, vtkImplicitVolume, vtkImplicitWindowFunction, vtkPerlinNoise, vtkSphere, and vtkSuperquadric.

int vtkImplicitFunction::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject. Reimplemented in vtkPlane, vtkPlanes, vtkQuadric, vtkCone, vtkCylinder, vtkImplicitBoolean, vtkImplicitDataSet, vtkImplicitSelectionLoop, vtkImplicitSum, vtkImplicitVolume, vtkImplicitWindowFunction, vtkPerlinNoise, vtkSphere, and vtkSuperquadric.

virtual int vtkImplicitFunction::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject. Reimplemented in vtkPlane, vtkPlanes, vtkQuadric, vtkCone, vtkCylinder, vtkImplicitBoolean, vtkImplicitDataSet, vtkImplicitSelectionLoop, vtkImplicitSum, vtkImplicitVolume, vtkImplicitWindowFunction, vtkPerlinNoise, vtkSphere, and vtkSuperquadric.

vtkImplicitFunction* vtkImplicitFunction::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkObject. Reimplemented in vtkPlane, vtkPlanes, vtkQuadric, vtkCone, vtkCylinder, vtkImplicitBoolean, vtkImplicitDataSet, vtkImplicitSelectionLoop, vtkImplicitSum, vtkImplicitVolume, vtkImplicitWindowFunction, vtkPerlinNoise, vtkSphere, and vtkSuperquadric.

void vtkImplicitFunction::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkObject. Reimplemented in vtkPlane, vtkPlanes, vtkQuadric, vtkCone, vtkCylinder, vtkImplicitBoolean, vtkImplicitDataSet, vtkImplicitSelectionLoop, vtkImplicitSum, vtkImplicitVolume, vtkImplicitWindowFunction, vtkPerlinNoise, vtkSphere, and vtkSuperquadric.

unsigned long vtkImplicitFunction::GetMTime | ( |  | ) | `[virtual]`

| Overload standard modified time function. If Transform is modified, then this object is modified as well. Reimplemented from vtkObject. Reimplemented in vtkImplicitBoolean, vtkImplicitDataSet, vtkImplicitSelectionLoop, vtkImplicitSum, vtkImplicitVolume, and vtkImplicitWindowFunction.

float vtkImplicitFunction::FunctionValue | ( | const float | x[3] | ) |

| Evaluate function at position x-y-z and return value. Point x[3] is transformed through transform (if provided).

float vtkImplicitFunction::FunctionValue | ( | float | x,
|  | float | y,
|  | float | z
| ) | `[inline]`

| Evaluate function at position x-y-z and return value. Point x[3] is transformed through transform (if provided). Definition at line 83 of file vtkImplicitFunction.h.

void vtkImplicitFunction::FunctionGradient | ( | const float | x[3],
|  | float | g[3]
| ) |

| Evaluate function gradient at position x-y-z and pass back vector. Point x[3] is transformed through transform (if provided).

float* vtkImplicitFunction::FunctionGradient | ( | const float | x[3] | ) | `[inline]`

| Evaluate function gradient at position x-y-z and pass back vector. Point x[3] is transformed through transform (if provided). Definition at line 91 of file vtkImplicitFunction.h.

float* vtkImplicitFunction::FunctionGradient | ( | float | x,
|  | float | y,
|  | float | z
| ) | `[inline]`

| Evaluate function gradient at position x-y-z and pass back vector. Point x[3] is transformed through transform (if provided). Definition at line 94 of file vtkImplicitFunction.h.

virtual void vtkImplicitFunction::SetTransform | ( | vtkAbstractTransform * |  | ) | `[virtual]`

| Set/Get a transformation to apply to input points before executing the implicit function.

virtual vtkAbstractTransform* vtkImplicitFunction::GetTransform | ( |  | ) | `[virtual]`

| Set/Get a transformation to apply to input points before executing the implicit function.

virtual float vtkImplicitFunction::EvaluateFunction | ( | float | x[3] | ) | `[pure virtual]`

| Evaluate function at position x-y-z and return value. You should generally not call this method directly, you should use FunctionValue() instead. This method must be implemented by any derived class. Implemented in vtkPlane, vtkPlanes, vtkQuadric, vtkCone, vtkCylinder, vtkImplicitBoolean, vtkImplicitDataSet, vtkImplicitSelectionLoop, vtkImplicitSum, vtkImplicitVolume, vtkImplicitWindowFunction, vtkPerlinNoise, vtkSphere, and vtkSuperquadric. Referenced by vtkSuperquadric::EvaluateFunction(), vtkSphere::EvaluateFunction(), vtkPerlinNoise::EvaluateFunction(), vtkImplicitWindowFunction::EvaluateFunction(), vtkImplicitVolume::EvaluateFunction(), vtkImplicitSum::EvaluateFunction(), vtkImplicitSelectionLoop::EvaluateFunction(), vtkImplicitDataSet::EvaluateFunction(), vtkImplicitBoolean::EvaluateFunction(), vtkCylinder::EvaluateFunction(), vtkCone::EvaluateFunction(), vtkQuadric::EvaluateFunction(), vtkPlanes::EvaluateFunction(), and vtkPlane::EvaluateFunction().

float vtkImplicitFunction::EvaluateFunction | ( | float | x,
|  | float | y,
|  | float | z
| ) | `[inline]`

| Evaluate function at position x-y-z and return value. You should generally not call this method directly, you should use FunctionValue() instead. This method must be implemented by any derived class. Reimplemented in vtkPlane, vtkPlanes, vtkQuadric, vtkCone, vtkCylinder, vtkImplicitBoolean, vtkImplicitDataSet, vtkImplicitSelectionLoop, vtkImplicitSum, vtkImplicitVolume, vtkImplicitWindowFunction, vtkPerlinNoise, vtkSphere, and vtkSuperquadric. Definition at line 111 of file vtkImplicitFunction.h.

virtual void vtkImplicitFunction::EvaluateGradient | ( | float | x[3],
|  | float | g[3]
| ) | `[pure virtual]`

| Evaluate function gradient at position x-y-z and pass back vector. You should generally not call this method directly, you should use FunctionGradient() instead. This method must be implemented by any derived class. Implemented in vtkPlane, vtkPlanes, vtkQuadric, vtkCone, vtkCylinder, vtkImplicitBoolean, vtkImplicitDataSet, vtkImplicitSelectionLoop, vtkImplicitSum, vtkImplicitVolume, vtkImplicitWindowFunction, vtkPerlinNoise, vtkSphere, and vtkSuperquadric.

## Member Data Documentation

vtkAbstractTransform* vtkImplicitFunction::Transform`[protected]`

| Definition at line 125 of file vtkImplicitFunction.h.

float vtkImplicitFunction::ReturnValue[3]`[protected]`

| Definition at line 126 of file vtkImplicitFunction.h.

The documentation for this class was generated from the following file:

- Common/vtkImplicitFunction.h